//dbio.java Q1 2004
//Features:
// opens files for writing
// opens files for reading
// reads lines (formatted)

import java.io.*;
//import java.util.*;

public class dbio
{
	static final int version = 1;

	//Open file for reading
	public BufferedReader fopenr(String fname)
	{
		BufferedReader in = null;
		
		try
		{
			in = new BufferedReader(
				new FileReader( fname )
				);
		}
		catch(FileNotFoundException e)
		{
			System.err.println("E <dbio> " + e.getMessage());
			return null;
		}
		catch(IOException e)
		{
			e.printStackTrace();
			return null;
		}

		return in;
	}
	
	//Returns key and value in an array[2]
	public String[] readLine(BufferedReader in)
	{
		if (in == null) return null;
		int colon;
		String[] part = null;
		String line, key, value;
		
		while(true)
		{
			try
			{
				if (in.ready())
				{
					line = in.readLine().trim();
				}
				else
					return null;
			}
			catch(IOException e)
			{
				e.printStackTrace();
				return null;
			}

			if (line.length() < 3)     continue;
			if (line.startsWith(";"))  continue;
			if (line.startsWith("#"))  continue;
			if (line.startsWith("//")) continue;

			colon = line.indexOf(":");
			if (colon <= 0) continue;

			key   = line.substring(0, colon);
			value = line.substring(colon + 1);
			if (value == null || value.length() < 1)
				continue;

			part = new String[2];
			part[0] = key;
			part[1] = value;

			break;
		}
		
		return part;
	}

	public void close(BufferedReader in)
	{
		try
		{
			in.close();
		}
		catch(IOException e)
		{
			e.printStackTrace();
		}
	}

	//Open file for writing
	public PrintWriter fopenw(String fname)
	{
		PrintWriter pw;

		try
		{
			pw = new PrintWriter(
				new FileOutputStream(fname, false)
				);
		}
		catch(Exception e)
		{
			e.printStackTrace();
			return null;
		}

		return pw;
	}
}
